package de.web.minecraftandi;

import net.minecraft.server.Packet20NamedEntitySpawn;
import net.minecraft.server.Packet29DestroyEntity;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.craftbukkit.entity.CraftPlayer;
import org.bukkit.entity.Arrow;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;

public class xArcher {
	private static xLevel plugin;
    
    public static void startup(final xLevel plugin) {
        xArcher.plugin = plugin;
    }
    
	public static boolean skill1(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.ARROW;
		boolean hasItem = false;
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			hasItem = true;
		}
		
		boolean canUse = false;

		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);	
	
			int fireTicks = 3000;
			if (level >= 16) {
				fireTicks = 8000;
			} else if (level >= 11) {
				fireTicks = 5000;
			}
			
			Arrow arrow = player.shootArrow();
			
			xEffectManager.setArcherEffectFireArrow(playername, arrow, fireTicks);
			
			canUse = true;
			
			if (canUse) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
				int exp = Integer.parseInt(split[2]);
				exp = exp + 10;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
		}
		return canUse;
	}

	public static boolean skill2(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.FEATHER;
		boolean hasItem = false;
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			hasItem = true;
		}
		
		boolean canUse = false;

		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int duration = 10000;
			if (level >= 16) {
				duration = 20000;
			} else if (level >= 11) {
				duration = 15000;
			}
			
			player.sendMessage(ChatColor.GRAY + "*** You have used your invisibility skill!");
			
			xArcher.setInvisible(player);
			
			xEffectManager.setArcherEffectInvisible(playername, duration);
			
			canUse = true;
			
			if (canUse) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
				int exp = Integer.parseInt(split[2]);
				exp = exp + 15;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
		}
		return canUse;
	}
	
	public static void setInvisible(Player player) {
		Player[] playerList = plugin.getServer().getOnlinePlayers();
		
		for (Player hideFromPlayer : playerList) {
 			Location loc1 = player.getLocation();
  			Location loc2 = hideFromPlayer.getLocation();
    		double distance = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
   			if ((hideFromPlayer.getName().equalsIgnoreCase(player.getName())) || (distance >= 512.0D))
    			continue;
      		CraftPlayer hide = (CraftPlayer)player;
     		CraftPlayer hideFrom = (CraftPlayer)hideFromPlayer;
     		if(xConfig.usePermissions) {
	     		if (!xLevel.permissionHandler.has(hideFromPlayer, "xlevel.admin.seeinvisibles")) {
	     			hideFrom.getHandle().netServerHandler.sendPacket(new Packet29DestroyEntity(hide.getEntityId()));
	     		}
     		}
		}
	}
	
	public static void removeInvisible(Player player) {
		String playername = player.getName();
		xEffectManager.archerEffectInvisibleSkillUseTime.remove(playername);
		xEffectManager.archerEffectInvisibleSkillDuration.remove(playername);
		player.sendMessage(ChatColor.GRAY + "Your invisibility effect has gone!");
		
		Player[] playerList = plugin.getServer().getOnlinePlayers();
		
		for (Player unhideFromPlayer : playerList) {
			Location loc1 = player.getLocation();
			Location loc2 = unhideFromPlayer.getLocation();
			double distance = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
			if ((unhideFromPlayer.getName().equalsIgnoreCase(player.getName())) || (distance >= 512.0D))
				continue;
			CraftPlayer unhide = (CraftPlayer)player;
			CraftPlayer unhideFrom = (CraftPlayer)unhideFromPlayer;
			unhideFrom.getHandle().netServerHandler.sendPacket(new Packet20NamedEntitySpawn(unhide.getHandle()));
		}
	}
    
	public static boolean skill3(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.ARROW;
		boolean hasItem = false;
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			hasItem = true;
		}
		
		boolean canUse = false;

		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int damage = 2;
			if (level >= 16) {
				damage = 4;
			} else if (level >= 11) {
				damage = 3;
			}
			
			Arrow arrow = player.shootArrow();
			
			xEffectManager.setArcherEffectCriticalArrow(playername, arrow, damage);
			
			canUse = true;
			
			if (canUse) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
				int exp = Integer.parseInt(split[2]);
				exp = exp + 20;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
		}
		return canUse;
	}
    
	public static boolean skill4(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.ARROW;
		boolean hasItem = false;
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			hasItem = true;
		}
		
		boolean canUse = false;

		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int distance = 10;
			if (level >= 16) {
				distance = 20;
			} else if (level >= 11) {
				distance = 15;
			}
			
			Arrow arrow = player.shootArrow();
			
			xEffectManager.setArcherEffectHook(playername, arrow, distance);
			
			canUse = true;
			
			if (canUse) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
			}
		}
		return canUse;
	}
    
	public static boolean skill5(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.ARROW;
		boolean hasItem = false;
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			hasItem = true;
		}
		
		boolean canUse = false;

		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);	
	
			int poisonStrikes = 3;
			if (level >= 16) {
				poisonStrikes = 8;
			} else if (level >= 11) {
				poisonStrikes = 5;
			}
			
			Arrow arrow = player.shootArrow();
			
			xEffectManager.setArcherEffectPoisonedArrow(playername, arrow, poisonStrikes);
			
			canUse = true;
			
			if (canUse) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
				int exp = Integer.parseInt(split[2]);
				exp = exp + 30;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
		}
		return canUse;
	}
}
