package de.web.minecraftandi;

import org.bukkit.ChatColor;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.block.BlockListener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;

/**
 * Handle block related events
 * @author Andi
 */
public class xBlockListener extends BlockListener {
    public xBlockListener(final xLevel plugin) {
    }
    
    public void onBlockBreak(BlockBreakEvent event)
    {
    	Player player = event.getPlayer();
    	Block block = event.getBlock();
    	String name = player.getName();
    	
    	if (xEffectManager.getArcherEffectInvisible(name)) {
    		xArcher.removeInvisible(player);
		}
    	
    	String playerData = xDataManager.getData(name);
    	if (!playerData.equalsIgnoreCase("none")) {
	    	String[] split = playerData.split(" ");
	
			int level = Integer.parseInt(split[1]);
			int exp = Integer.parseInt(split[2]);
			int multiplier = xBlockExpMultiplier.getBlockBreakExpMultiplier(block);
			
			if(multiplier!=0) {
				exp = exp + multiplier;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(name, playerData);
			}
    	}
    }
    
    public void onBlockPlace(BlockPlaceEvent event)
    {
    	Player player = event.getPlayer();
    	Block block = event.getBlock();
    	String name = player.getName();

    	if (xEffectManager.getArcherEffectInvisible(name)) {
    		xArcher.removeInvisible(player);
		}
    	
    	String playerData = xDataManager.getData(name);
    	if (!playerData.equalsIgnoreCase("none")) {
	    	String[] split = playerData.split(" ");
	
			int level = Integer.parseInt(split[1]);
			int exp = Integer.parseInt(split[2]);
			int multiplier = xBlockExpMultiplier.getBlockPlaceExpMultiplier(block);
			if(multiplier!=0) {
				exp = exp + multiplier;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(name, playerData);
			}
    	}
    }
}
