package de.web.minecraftandi;

import java.util.ArrayList;
import java.util.concurrent.ConcurrentHashMap;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.entity.Arrow;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.entity.Wolf;
import org.bukkit.util.Vector;

public class xEffectManager {
    private static xLevel plugin;
    
    public static void startup(final xLevel plugin) {
    	xEffectManager.plugin = plugin;
    }
    
	public static final int magicianEffectIcyWindDuration = 5000;
	public static ConcurrentHashMap<String, ArrayList<Block>> magicianEffectIcyWindLocation = new ConcurrentHashMap<String, ArrayList<Block>>();
	public static ConcurrentHashMap<String, Long> magicianEffectIcyWindSkillUseTime = new ConcurrentHashMap<String, Long>();
	
	public static boolean getMagicianEffectIcyWind(String playername) {
		if (magicianEffectIcyWindSkillUseTime.containsKey(playername)) {
			long skillUseTime = magicianEffectIcyWindSkillUseTime.get(playername);
			long now = System.currentTimeMillis();
			long timeDiverse = now - skillUseTime;
			
			if (timeDiverse <= magicianEffectIcyWindDuration) {
				return true;
			} else if (magicianEffectIcyWindLocation.containsKey(playername)) {
				ArrayList<Block> removeList = magicianEffectIcyWindLocation.get(playername);
				for (int j = 0; j < removeList.size(); j++) {
					Block remove = (Block)removeList.get(j);
					if (remove.getType() == Material.SNOW) {
							remove.setType(Material.AIR);
					}
				}
				magicianEffectIcyWindSkillUseTime.remove(playername);
				magicianEffectIcyWindLocation.remove(playername);
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "Your icy wind effect has gone!");
			}
		}
		return false;
	}

	public static void setMagicianEffectIcyWind(String playername, ArrayList<Block> location) {
		long now = System.currentTimeMillis();
		magicianEffectIcyWindLocation.put(playername, location);
		magicianEffectIcyWindSkillUseTime.put(playername, now);
	}
	
	public static final int magicianEffectLeavesJailDuration = 8000;
	public static ConcurrentHashMap<String, ArrayList<Block>> magicianEffectLeavesJailLocation = new ConcurrentHashMap<String, ArrayList<Block>>();
	public static ConcurrentHashMap<String, Long> magicianEffectLeavesJailSkillUseTime = new ConcurrentHashMap<String, Long>();
	
	public static boolean getMagicianEffectLeavesJail(String playername) {
		if (magicianEffectLeavesJailSkillUseTime.containsKey(playername)) {
			long skillUseTime = magicianEffectLeavesJailSkillUseTime.get(playername);
			long now = System.currentTimeMillis();
			long timeDiverse = now - skillUseTime;
			
			if (timeDiverse <= magicianEffectLeavesJailDuration) {
				return true;
			} else if (magicianEffectLeavesJailLocation.containsKey(playername)) {
				ArrayList<Block> removeList = magicianEffectLeavesJailLocation.get(playername);
				for (int j = 0; j < removeList.size(); j++) {
					Block remove = (Block)removeList.get(j);
					if (remove.getType() == Material.LEAVES) {
							remove.setType(Material.AIR);
					}
				}
				magicianEffectLeavesJailSkillUseTime.remove(playername);
				magicianEffectLeavesJailLocation.remove(playername);
				
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "Your leaves jail effect has gone!");
			}
		}
		return false;
	}

	public static void setMagicianEffectLeavesJail(String playername, ArrayList<Block> location) {
		long now = System.currentTimeMillis();
		magicianEffectLeavesJailLocation.put(playername, location);
		magicianEffectLeavesJailSkillUseTime.put(playername, now);
	}
	
	public static final int priestEffectSummonWolvesDuration = 20000;
	public static ConcurrentHashMap<String, ArrayList<Wolf>> priestEffectSummonWolvesEntities = new ConcurrentHashMap<String, ArrayList<Wolf>>();
	public static ConcurrentHashMap<String, Long> priestEffectSummonWolvesSkillUseTime = new ConcurrentHashMap<String, Long>();
	
	public static boolean getPriestEffectSummonWolves(String playername) {
		if (priestEffectSummonWolvesSkillUseTime.containsKey(playername)) {
			long skillUseTime = priestEffectSummonWolvesSkillUseTime.get(playername);
			long now = System.currentTimeMillis();
			long timeDiverse = now - skillUseTime;
			
			if (timeDiverse <= priestEffectSummonWolvesDuration) {
				return true;
			} else if (priestEffectSummonWolvesEntities.containsKey(playername)) {
				ArrayList<Wolf> removeList = priestEffectSummonWolvesEntities.get(playername);
				for (int j = 0; j < removeList.size(); j++) {
					Wolf remove = (Wolf)removeList.get(j);
					remove.damage(20);
				}
				priestEffectSummonWolvesSkillUseTime.remove(playername);
				priestEffectSummonWolvesEntities.remove(playername);
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "Your wolves died - if they haven't already!");
			}
		}
		return false;
	}

	public static void setPriestEffectSummonWolves(String playername, ArrayList<Wolf> location) {
		long now = System.currentTimeMillis();
		priestEffectSummonWolvesEntities.put(playername, location);
		priestEffectSummonWolvesSkillUseTime.put(playername, now);
	}
	
	public static final int priestEffectDefBuffDuration = 30000;
	public static ConcurrentHashMap<String, Player> priestEffectDefBuffPlayer = new ConcurrentHashMap<String, Player>();
	public static ConcurrentHashMap<String, Long> priestEffectDefBuffSkillUseTime = new ConcurrentHashMap<String, Long>();
	
	public static boolean getPriestEffectDefBuff(String playername) {
		if (priestEffectDefBuffSkillUseTime.containsKey(playername)) {
			long skillUseTime = priestEffectDefBuffSkillUseTime.get(playername);
			long now = System.currentTimeMillis();
			long timeDiverse = now - skillUseTime;
			
			if (timeDiverse <= priestEffectDefBuffDuration) {
				return true;
			} else if (priestEffectDefBuffPlayer.containsKey(playername)) {
				priestEffectDefBuffSkillUseTime.remove(playername);
				priestEffectDefBuffPlayer.remove(playername);
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "Your defense buff has gone!");
			}
		}
		return false;
	}

	public static void setPriestEffectDefBuff(String playername, Player player) {
		long now = System.currentTimeMillis();
		priestEffectDefBuffPlayer.put(player.getName(), player);
		priestEffectDefBuffSkillUseTime.put(player.getName(), now);
	}
	
	public static final int priestEffectStrBuffDuration = 30000;
	public static ConcurrentHashMap<String, Player> priestEffectStrBuffPlayer = new ConcurrentHashMap<String, Player>();
	public static ConcurrentHashMap<String, Long> priestEffectStrBuffSkillUseTime = new ConcurrentHashMap<String, Long>();
	
	public static boolean getPriestEffectStrBuff(String playername) {
		if (priestEffectStrBuffSkillUseTime.containsKey(playername)) {
			long skillUseTime = priestEffectStrBuffSkillUseTime.get(playername);
			long now = System.currentTimeMillis();
			long timeDiverse = now - skillUseTime;
			
			if (timeDiverse <= priestEffectStrBuffDuration) {
				return true;
			} else if (priestEffectStrBuffPlayer.containsKey(playername)) {
				priestEffectStrBuffSkillUseTime.remove(playername);
				priestEffectStrBuffPlayer.remove(playername);
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "Your strength buff has gone!");
			}
		}
		return false;
	}

	public static void setPriestEffectStrBuff(String playername, Player player) {
		long now = System.currentTimeMillis();
		priestEffectStrBuffPlayer.put(player.getName(), player);
		priestEffectStrBuffSkillUseTime.put(player.getName(), now);
	}
	
	public static final int priestEffectSpeedBuffDuration = 30000;
	public static ConcurrentHashMap<String, Player> priestEffectSpeedBuffPlayer = new ConcurrentHashMap<String, Player>();
	public static ConcurrentHashMap<String, Long> priestEffectSpeedBuffSkillUseTime = new ConcurrentHashMap<String, Long>();
	
	public static boolean getPriestEffectSpeedBuff(String playername) {
		if (priestEffectSpeedBuffSkillUseTime.containsKey(playername)) {
			long skillUseTime = priestEffectSpeedBuffSkillUseTime.get(playername);
			long now = System.currentTimeMillis();
			long timeDiverse = now - skillUseTime;
			
			if (timeDiverse <= priestEffectSpeedBuffDuration) {
				return true;
			} else if (priestEffectSpeedBuffPlayer.containsKey(playername)) {
				priestEffectSpeedBuffSkillUseTime.remove(playername);
				priestEffectSpeedBuffPlayer.remove(playername);
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "Your speed buff has gone!");
			}
		}
		return false;
	}

	public static void setPriestEffectSpeedBuff(String playername, Player player) {
		long now = System.currentTimeMillis();
		priestEffectSpeedBuffPlayer.put(player.getName(), player);
		priestEffectSpeedBuffSkillUseTime.put(player.getName(), now);
	}

	public static ConcurrentHashMap<String, Integer> archerEffectFireArrowFireTicks = new ConcurrentHashMap<String, Integer>();
	public static ConcurrentHashMap<String, Arrow> archerEffectFireArrowArrow = new ConcurrentHashMap<String, Arrow>();
	public static ConcurrentHashMap<String, Vector> archerEffectFireArrowVector = new ConcurrentHashMap<String, Vector>();
	public static ConcurrentHashMap<String, Long> archerEffectFireArrowLastTimeSameVector = new ConcurrentHashMap<String, Long>();
	
	public static void checkArcherEffectFireArrow(String playername) {
		if (archerEffectFireArrowArrow.containsKey(playername)) {
			if (archerEffectFireArrowArrow.containsKey(playername)) {
				Arrow arrow = archerEffectFireArrowArrow.get(playername);
				long now = System.currentTimeMillis();
				if ((arrow.getVelocity().equals(archerEffectFireArrowVector.get(playername)) && ((now - archerEffectFireArrowLastTimeSameVector.get(playername)) > 100))) {
					
					ArrayList<Block> blockList = new ArrayList<Block>();
					Block targetBlock = arrow.getLocation().getBlock();
					Block eastBlock = targetBlock.getRelative(BlockFace.EAST);
					Block westBlock = targetBlock.getRelative(BlockFace.WEST);
					Block northBlock = targetBlock.getRelative(BlockFace.NORTH);
					Block southBlock = targetBlock.getRelative(BlockFace.SOUTH);
					Block northEastBlock = targetBlock.getRelative(BlockFace.NORTH_EAST);
					Block northWestBlock = targetBlock.getRelative(BlockFace.NORTH_WEST);
					Block southEastBlock = targetBlock.getRelative(BlockFace.SOUTH_EAST);
					Block southWestBlock = targetBlock.getRelative(BlockFace.SOUTH_WEST);
					
					if (targetBlock.getType() == Material.AIR && targetBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR) {
						targetBlock.setType(Material.FIRE);
						blockList.add(targetBlock);
					} else if (targetBlock.getRelative(BlockFace.DOWN).getType() == Material.AIR) {
						targetBlock.getRelative(BlockFace.DOWN).setType(Material.FIRE);
						blockList.add(targetBlock.getRelative(BlockFace.DOWN));
					} else if (targetBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						targetBlock.getRelative(BlockFace.UP).setType(Material.FIRE);
						blockList.add(targetBlock.getRelative(BlockFace.UP));
					}
					if (eastBlock.getType() == Material.AIR && eastBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR) {
						eastBlock.setType(Material.FIRE);
						blockList.add(eastBlock);
					} else if (eastBlock.getRelative(BlockFace.DOWN).getType() == Material.AIR) {
						eastBlock.getRelative(BlockFace.DOWN).setType(Material.FIRE);
						blockList.add(eastBlock.getRelative(BlockFace.DOWN));
					} else if (eastBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						eastBlock.getRelative(BlockFace.UP).setType(Material.FIRE);
						blockList.add(eastBlock.getRelative(BlockFace.UP));
					}
					if (westBlock.getType() == Material.AIR && westBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR) {
						westBlock.setType(Material.FIRE);
						blockList.add(westBlock);
					} else if (westBlock.getRelative(BlockFace.DOWN).getType() == Material.AIR) {
						westBlock.getRelative(BlockFace.DOWN).setType(Material.FIRE);
						blockList.add(westBlock.getRelative(BlockFace.DOWN));
					} else if (westBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						westBlock.getRelative(BlockFace.UP).setType(Material.FIRE);
						blockList.add(westBlock.getRelative(BlockFace.UP));
					}
					if (northBlock.getType() == Material.AIR && northBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR) {
						northBlock.setType(Material.FIRE);
						blockList.add(northBlock);
					} else if (northBlock.getRelative(BlockFace.DOWN).getType() == Material.AIR) {
						northBlock.getRelative(BlockFace.DOWN).setType(Material.FIRE);
						blockList.add(northBlock.getRelative(BlockFace.DOWN));
					} else if (northBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						northBlock.getRelative(BlockFace.UP).setType(Material.FIRE);
						blockList.add(northBlock.getRelative(BlockFace.UP));
					}
					if (southBlock.getType() == Material.AIR && southBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR) {
						southBlock.setType(Material.FIRE);
						blockList.add(southBlock);
					} else if (southBlock.getRelative(BlockFace.DOWN).getType() == Material.AIR) {
						southBlock.getRelative(BlockFace.DOWN).setType(Material.FIRE);
						blockList.add(southBlock.getRelative(BlockFace.DOWN));
					} else if (southBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						southBlock.getRelative(BlockFace.UP).setType(Material.FIRE);
						blockList.add(southBlock.getRelative(BlockFace.UP));
					}
					if (northEastBlock.getType() == Material.AIR && northEastBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR) {
						northEastBlock.setType(Material.FIRE);
						blockList.add(northEastBlock);
					} else if (northEastBlock.getRelative(BlockFace.DOWN).getType() == Material.AIR) {
						northEastBlock.getRelative(BlockFace.DOWN).setType(Material.FIRE);
						blockList.add(northEastBlock.getRelative(BlockFace.DOWN));
					} else if (northEastBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						northEastBlock.getRelative(BlockFace.UP).setType(Material.FIRE);
						blockList.add(northEastBlock.getRelative(BlockFace.UP));
					}
					if (northWestBlock.getType() == Material.AIR && northWestBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR) {
						northWestBlock.setType(Material.FIRE);
						blockList.add(northWestBlock);
					} else if (northWestBlock.getRelative(BlockFace.DOWN).getType() == Material.AIR) {
						northWestBlock.getRelative(BlockFace.DOWN).setType(Material.FIRE);
						blockList.add(northWestBlock.getRelative(BlockFace.DOWN));
					} else if (northWestBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						northWestBlock.getRelative(BlockFace.UP).setType(Material.FIRE);
						blockList.add(northWestBlock.getRelative(BlockFace.UP));
					}
					if (southEastBlock.getType() == Material.AIR && southEastBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR) {
						southEastBlock.setType(Material.FIRE);
						blockList.add(southEastBlock);
					} else if (southEastBlock.getRelative(BlockFace.DOWN).getType() == Material.AIR) {
						southEastBlock.getRelative(BlockFace.DOWN).setType(Material.FIRE);
						blockList.add(southEastBlock.getRelative(BlockFace.DOWN));
					} else if (southEastBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						southEastBlock.getRelative(BlockFace.UP).setType(Material.FIRE);
						blockList.add(southEastBlock.getRelative(BlockFace.UP));
					}
					if (southWestBlock.getType() == Material.AIR && southWestBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR) {
						southWestBlock.setType(Material.FIRE);
						blockList.add(southWestBlock);
					} else if (southWestBlock.getRelative(BlockFace.DOWN).getType() == Material.AIR) {
						southWestBlock.getRelative(BlockFace.DOWN).setType(Material.FIRE);
						blockList.add(southWestBlock.getRelative(BlockFace.DOWN));
					} else if (southWestBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						southWestBlock.getRelative(BlockFace.UP).setType(Material.FIRE);
						blockList.add(southWestBlock.getRelative(BlockFace.UP));
					}
					
					Player[] playerList = plugin.getServer().getOnlinePlayers();
					
					plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "*** You have used fire arrow!");
					
					for (Player victim : playerList) {
						Location loc1 = targetBlock.getLocation();
						Location loc2 = victim.getLocation();
					 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
					 	if (distanceAway >= 2.0D)
							continue;
					 	victim.sendMessage(ChatColor.GRAY + "*** You have been hit by a fire arrow!");
					}
					
					xEffectManager.setArcherEffectFireArrow(playername, blockList, archerEffectFireArrowFireTicks.get(playername));
					
					archerEffectFireArrowArrow.remove(playername);
				} else if (!arrow.getVelocity().equals(archerEffectFireArrowVector.get(playername))) {
					archerEffectFireArrowLastTimeSameVector.put(playername, now);
					archerEffectFireArrowVector.put(playername, arrow.getVelocity());
				}
			}
		}
	}

	public static void setArcherEffectFireArrow(String playername, Arrow arrow, int fireTicks) {
		long now = System.currentTimeMillis();
		archerEffectFireArrowArrow.put(playername, arrow);
		archerEffectFireArrowFireTicks.put(playername, fireTicks);
		archerEffectFireArrowLastTimeSameVector.put(playername, now);
		archerEffectFireArrowVector.put(playername, arrow.getVelocity());
	}
	
	public static ConcurrentHashMap<String, Integer> archerEffectFireArrowSkillDuration = new ConcurrentHashMap<String, Integer>();
	public static ConcurrentHashMap<String, Long> archerEffectFireArrowSkillUseTime = new ConcurrentHashMap<String, Long>();
	public static ConcurrentHashMap<String, ArrayList<Block>> archerEffectFireArrowSkillLocation = new ConcurrentHashMap<String, ArrayList<Block>>();
	
	public static boolean getArcherEffectFireArrow(String playername) {
		if (archerEffectFireArrowSkillUseTime.containsKey(playername)) {
			long skillUseTime = archerEffectFireArrowSkillUseTime.get(playername);
			long now = System.currentTimeMillis();
			long timeDiverse = now - skillUseTime;
			
			if (timeDiverse <= archerEffectFireArrowSkillDuration.get(playername)) {
				ArrayList<Block> replaceList = archerEffectFireArrowSkillLocation.get(playername);
				for (int j = 0; j < replaceList.size(); j++) {
					Block replace = (Block)replaceList.get(j);
					if (replace.getType() != Material.FIRE) {
						replace.setType(Material.FIRE);
					}
				}
				return true;
			} else if (archerEffectFireArrowSkillLocation.containsKey(playername)) {
				ArrayList<Block> removeList = archerEffectFireArrowSkillLocation.get(playername);
				for (int j = 0; j < removeList.size(); j++) {
					Block remove = (Block)removeList.get(j);
					if (remove.getType() == Material.FIRE) {
							remove.setType(Material.AIR);
					}
				}
				archerEffectFireArrowSkillDuration.remove(playername);
				archerEffectFireArrowSkillUseTime.remove(playername);
				archerEffectFireArrowSkillLocation.remove(playername);
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "Your fire arrow effect has gone!");
			}
		}
		return false;
	}

	public static void setArcherEffectFireArrow(String playername, ArrayList<Block> blockList, int fireTicks) {
		long now = System.currentTimeMillis();
		archerEffectFireArrowSkillDuration.put(playername, fireTicks);
		archerEffectFireArrowSkillLocation.put(playername, blockList);
		archerEffectFireArrowSkillUseTime.put(playername, now);
	}
	
	public static ConcurrentHashMap<String, Integer> archerEffectInvisibleSkillDuration = new ConcurrentHashMap<String, Integer>();
	public static ConcurrentHashMap<String, Long> archerEffectInvisibleSkillUseTime = new ConcurrentHashMap<String, Long>();
	
	public static boolean getArcherEffectInvisible(String playername) {
		if (archerEffectInvisibleSkillUseTime.containsKey(playername)) {
			long skillUseTime = archerEffectInvisibleSkillUseTime.get(playername);
			long now = System.currentTimeMillis();
			long timeDiverse = now - skillUseTime;
			
			if (timeDiverse <= archerEffectInvisibleSkillDuration.get(playername)) {
				return true;
			} else if (archerEffectInvisibleSkillUseTime.containsKey(playername)) {
				xArcher.removeInvisible(plugin.getServer().getPlayer(playername));
			}
		}
		return false;
	}
	
	public static void setArcherEffectInvisible(String playername, int duration) {
		long now = System.currentTimeMillis();
		archerEffectInvisibleSkillDuration.put(playername, duration);
		archerEffectInvisibleSkillUseTime.put(playername, now);
	}

	public static ConcurrentHashMap<String, Integer> archerEffectCriticalArrowDamage = new ConcurrentHashMap<String, Integer>();
	public static ConcurrentHashMap<String, Arrow> archerEffectCriticalArrowArrow = new ConcurrentHashMap<String, Arrow>();
	public static ConcurrentHashMap<String, Vector> archerEffectCriticalArrowVector = new ConcurrentHashMap<String, Vector>();
	public static ConcurrentHashMap<String, Long> archerEffectCriticalArrowLastTimeSameVector = new ConcurrentHashMap<String, Long>();
	
	public static void checkArcherEffectCriticalArrow(String playername) {
		if (archerEffectCriticalArrowArrow.containsKey(playername)) {
			if (archerEffectCriticalArrowArrow.containsKey(playername)) {
				Arrow arrow = archerEffectCriticalArrowArrow.get(playername);
				long now = System.currentTimeMillis();
				if ((arrow.getVelocity().equals(archerEffectCriticalArrowVector.get(playername)) && ((now - archerEffectCriticalArrowLastTimeSameVector.get(playername)) > 100))) {
					
					Block targetBlock = arrow.getLocation().getBlock();
					
					Player[] playerList = plugin.getServer().getOnlinePlayers();

				 	plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "*** You have used critical arrow!");
				 	
					for (Player victim : playerList) {
						Location loc1 = targetBlock.getLocation();
						Location loc2 = victim.getLocation();
					 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
					 	if (distanceAway >= 2.0D)
							continue;
					 	victim.damage(archerEffectCriticalArrowDamage.get(playername));
						victim.sendMessage(ChatColor.GRAY + "*** You have been hit by a critical arrow!");
					}
					archerEffectCriticalArrowArrow.remove(playername);
				} else if (!arrow.getVelocity().equals(archerEffectCriticalArrowVector.get(playername))) {
					archerEffectCriticalArrowLastTimeSameVector.put(playername, now);
					archerEffectCriticalArrowVector.put(playername, arrow.getVelocity());
				}
			}
		}
	}

	public static void setArcherEffectCriticalArrow(String playername, Arrow arrow, int damage) {
		long now = System.currentTimeMillis();
		archerEffectCriticalArrowDamage.put(playername, damage);
		archerEffectCriticalArrowArrow.put(playername, arrow);
		archerEffectCriticalArrowLastTimeSameVector.put(playername, now);
		archerEffectCriticalArrowVector.put(playername, arrow.getVelocity());
	}

	public static ConcurrentHashMap<String, Integer> archerEffectHookDistance = new ConcurrentHashMap<String, Integer>();
	public static ConcurrentHashMap<String, Arrow> archerEffectHookArrow = new ConcurrentHashMap<String, Arrow>();
	public static ConcurrentHashMap<String, Vector> archerEffectHookVector = new ConcurrentHashMap<String, Vector>();
	public static ConcurrentHashMap<String, Long> archerEffectHookLastTimeSameVector = new ConcurrentHashMap<String, Long>();
	
	public static void checkArcherEffectHook(String playername) {
		if (archerEffectHookArrow.containsKey(playername)) {
			if (archerEffectHookArrow.containsKey(playername)) {
				Arrow arrow = archerEffectHookArrow.get(playername);
				long now = System.currentTimeMillis();
				if ((arrow.getVelocity().equals(archerEffectHookVector.get(playername)) && ((now - archerEffectHookLastTimeSameVector.get(playername)) > 100))) {
					
					Block targetBlock = arrow.getLocation().getBlock();
					Block oneAbove = targetBlock.getRelative(BlockFace.UP);
					Block twoAbove = oneAbove.getRelative(BlockFace.UP);
					
					Player player = plugin.getServer().getPlayer(playername);
					int distance = archerEffectHookDistance.get(playername);
					
					boolean canUse = false;
					
					if ((oneAbove.getType() == Material.AIR) && (twoAbove.getType() == Material.AIR)) {
						Location loc1 = player.getLocation();
						Location loc2 = targetBlock.getLocation();
						double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
						switch(distance) {
							case 10:
								if (distanceAway <= 10.0D) {
									player.sendMessage(ChatColor.GRAY + "*** You have yourself hooked!");
									canUse = true;
									player.teleport(targetBlock.getRelative(BlockFace.UP).getLocation());
								} else {
									player.sendMessage(ChatColor.GRAY + "*** You can not hook that far!");
								}
								break;
							case 15:
								if (distanceAway <= 15.0D) {
									player.sendMessage(ChatColor.GRAY + "*** You have yourself hooked!");
									canUse = true;
									player.teleport(targetBlock.getRelative(BlockFace.UP).getLocation());
								} else {
									player.sendMessage(ChatColor.GRAY + "*** You can not hook that far!");
								}
								break;
							case 20:
								if (distanceAway <= 20.0D) {
									player.sendMessage(ChatColor.GRAY + "*** You have yourself hooked!");
									canUse = true;
									player.teleport(targetBlock.getRelative(BlockFace.UP).getLocation());
								} else {
									player.sendMessage(ChatColor.GRAY + "*** You can not hook that far!");
								}
								break;
							default:
								player.sendMessage(ChatColor.GRAY + "*** You found a bug! Please report an admin!");
								break;
						}
					} else {
						player.sendMessage(ChatColor.GRAY + "*** You can not hook there!");
					}
					
					archerEffectHookArrow.remove(playername);
					archerEffectHookDistance.remove(playername);
					archerEffectHookLastTimeSameVector.remove(playername);
					archerEffectHookVector.remove(playername);
					
					if (!canUse) {
						xSkillManager.setSkillLastUsed(playername, 4, System.currentTimeMillis() - 60000L);
					} else {
						String playerData = xDataManager.getData(playername);
						String[] split = playerData.split(" ");
						int level = Integer.parseInt(split[1]);
						
						int exp = Integer.parseInt(split[2]);
						exp = exp + 25;
						if (exp>=(300*(level+1))) {
							exp = 0;
							if(level<20) {
								level++;
							}
							player.sendMessage(ChatColor.YELLOW + "[xLevel]");
							player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
							if (split[0].equalsIgnoreCase("Commoner")) {
								player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
							}
							if (level == 20) {
								player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
							}
						}
						
						String[] split2 = playerData.split(" ");
						playerData = split2[0] + " " + level + " " + exp;
						xDataManager.setData(playername, playerData);
					}
				} else if (!arrow.getVelocity().equals(archerEffectHookVector.get(playername))) {
					archerEffectHookLastTimeSameVector.put(playername, now);
					archerEffectHookVector.put(playername, arrow.getVelocity());
				}
			}
		}
	}

	public static void setArcherEffectHook(String playername, Arrow arrow, int distance) {
		long now = System.currentTimeMillis();
		archerEffectHookDistance.put(playername, distance);
		archerEffectHookArrow.put(playername, arrow);
		archerEffectHookLastTimeSameVector.put(playername, now);
		archerEffectHookVector.put(playername, arrow.getVelocity());
	}

	public static ConcurrentHashMap<String, Integer> archerEffectPoisonedArrowPoisonStrikes = new ConcurrentHashMap<String, Integer>();
	public static ConcurrentHashMap<String, Arrow> archerEffectPoisonedArrowArrow = new ConcurrentHashMap<String, Arrow>();
	public static ConcurrentHashMap<String, Vector> archerEffectPoisonedArrowVector = new ConcurrentHashMap<String, Vector>();
	public static ConcurrentHashMap<String, Long> archerEffectPoisonedArrowLastTimeSameVector = new ConcurrentHashMap<String, Long>();
	
	public static void checkArcherEffectPoisonedArrow(String playername) {
		if (archerEffectPoisonedArrowArrow.containsKey(playername)) {
			if (archerEffectPoisonedArrowArrow.containsKey(playername)) {
				Arrow arrow = archerEffectPoisonedArrowArrow.get(playername);
				long now = System.currentTimeMillis();
				if ((arrow.getVelocity().equals(archerEffectPoisonedArrowVector.get(playername)) && ((now - archerEffectPoisonedArrowLastTimeSameVector.get(playername)) > 100))) {
					
					Block targetBlock = arrow.getLocation().getBlock();
					
					Player[] playerList = plugin.getServer().getOnlinePlayers();
					
					plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "*** You have used poisoned arrow!");
					
					for (Player victim : playerList) {
						Location loc1 = targetBlock.getLocation();
						Location loc2 = victim.getLocation();
					 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
					 	if (distanceAway >= 2.0D)
							continue;
					 	victim.sendMessage(ChatColor.GRAY + "*** You have been hit by a poisoned arrow!");
					 	xEffectManager.setArcherEffectPoisonedArrow(victim.getName(), archerEffectPoisonedArrowPoisonStrikes.get(playername));
					}
					
					archerEffectPoisonedArrowArrow.remove(playername);
				} else if (!arrow.getVelocity().equals(archerEffectPoisonedArrowVector.get(playername))) {
					archerEffectPoisonedArrowLastTimeSameVector.put(playername, now);
					archerEffectPoisonedArrowVector.put(playername, arrow.getVelocity());
				}
			}
		}
	}

	public static void setArcherEffectPoisonedArrow(String playername, Arrow arrow, int poisonStrikes) {
		long now = System.currentTimeMillis();
		archerEffectPoisonedArrowArrow.put(playername, arrow);
		archerEffectPoisonedArrowPoisonStrikes.put(playername, poisonStrikes);
		archerEffectPoisonedArrowLastTimeSameVector.put(playername, now);
		archerEffectPoisonedArrowVector.put(playername, arrow.getVelocity());
	}
	
	public static ConcurrentHashMap<String, Integer> archerEffectPoisonedArrowSkillDuration = new ConcurrentHashMap<String, Integer>();
	public static ConcurrentHashMap<String, Long> archerEffectPoisonedArrowSkillUseTime = new ConcurrentHashMap<String, Long>();
	public static ConcurrentHashMap<String, Long> archerEffectPoisonedArrowSkillLastTimeHit = new ConcurrentHashMap<String, Long>();
	
	public static boolean getArcherEffectPoisonedArrow(String playername) {
		if (archerEffectPoisonedArrowSkillUseTime.containsKey(playername)) {
			long skillUseTime = archerEffectPoisonedArrowSkillUseTime.get(playername);
			long now = System.currentTimeMillis();
			long timeDiverse = now - skillUseTime;
			
			if (timeDiverse <= (archerEffectPoisonedArrowSkillDuration.get(playername))*3000) {
				Player player = plugin.getServer().getPlayer(playername);
				
				long lastTimeHit = archerEffectPoisonedArrowSkillLastTimeHit.get(playername);
				timeDiverse = now - lastTimeHit;;
				if (timeDiverse >= 3000) {
					archerEffectPoisonedArrowSkillLastTimeHit.put(playername, now);
					player.damage(1);
				}
				return true;
			} else if (archerEffectPoisonedArrowSkillDuration.containsKey(playername)) {
				archerEffectPoisonedArrowSkillDuration.remove(playername);
				archerEffectPoisonedArrowSkillUseTime.remove(playername);
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "Your are no longer poisoned!");
			}
		}
		return false;
	}

	public static void setArcherEffectPoisonedArrow(String playername, int poisonStrikes) {
		long now = System.currentTimeMillis();
		archerEffectPoisonedArrowSkillDuration.put(playername, poisonStrikes);
		archerEffectPoisonedArrowSkillUseTime.put(playername, now);
		archerEffectPoisonedArrowSkillLastTimeHit.put(playername, now);
		Player player = plugin.getServer().getPlayer(playername);
		player.damage(1);
	}
	
	public static ConcurrentHashMap<String, Integer> warriorEffectPushPlayer = new ConcurrentHashMap<String, Integer>();
	
	public static boolean getWarriorEffectPush(Player attacker, LivingEntity entity) {
		String playername = attacker.getName();
		if (warriorEffectPushPlayer.containsKey(playername)) {
			Block block = entity.getLocation().getBlock();
			for (int i = 1; i <= warriorEffectPushPlayer.get(playername); i++) {
				block = block.getRelative(BlockFace.UP);
			}
			if (block.getType() == Material.AIR && block.getRelative(BlockFace.UP).getType() == Material.AIR) {
				entity.teleport(block.getLocation());
				attacker.sendMessage(ChatColor.GRAY + "*** You have used push!");
				if (entity instanceof Player) {
					((Player) entity).sendMessage(ChatColor.GRAY + "*** You have been hit by " + attacker.getName() + "'s push!");
				}
				warriorEffectPushPlayer.remove(playername);
			} else {
				attacker.sendMessage(ChatColor.GRAY + "*** Your target can't be pushed there!");
			}
			return true;
		} else {
			return false;
		}
	}

	public static void setWarriorEffectPush(String playername, int height) {
		warriorEffectPushPlayer.put(playername, height);
	}
	
	public static ConcurrentHashMap<String, Long> warriorEffectSprintPlayer = new ConcurrentHashMap<String, Long>();
	public static ConcurrentHashMap<String, Long> warriorEffectSprintUseTime = new ConcurrentHashMap<String, Long>();
	
	public static boolean getWarriorEffectSprint(String playername) {
		if (warriorEffectSprintPlayer.containsKey(playername)) {
			Long timeDiverse = System.currentTimeMillis() - warriorEffectSprintUseTime.get(playername);
			if (timeDiverse <= warriorEffectSprintPlayer.get(playername)) {
				return true;
			} else {
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "*** Your sprint effect has gone!");
				warriorEffectSprintPlayer.remove(playername);
				warriorEffectSprintUseTime.remove(playername);
				return false;
			}
		} else {
			return false;
		}
	}

	public static void setWarriorEffectSprint(String playername, Long duration) {
		Long now = System.currentTimeMillis();
		warriorEffectSprintPlayer.put(playername, duration);
		warriorEffectSprintUseTime.put(playername, now);
		plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "*** You used your sprint effect! Crouch down!");
	}
	
	public static ConcurrentHashMap<String, Long> warriorEffectCripplingSkillPlayer = new ConcurrentHashMap<String, Long>();
	public static ConcurrentHashMap<String, Long> warriorEffectCripplingSkillUseTime = new ConcurrentHashMap<String, Long>();
	
	public static boolean checkWarriorEffectCrippling(String playername) {
		if (warriorEffectCripplingSkillPlayer.containsKey(playername)) {
			Long now = System.currentTimeMillis();
			Long timeDiverse = now - warriorEffectCripplingSkillUseTime.get(playername);
			if (timeDiverse <= warriorEffectCripplingSkillPlayer.get(playername)) {
				return true;
			} else {
				plugin.getServer().getPlayer(playername).sendMessage(ChatColor.GRAY + "*** You are no longer crippled!");
				warriorEffectCripplingSkillPlayer.remove(playername);
				warriorEffectCripplingSkillUseTime.remove(playername);
				return false;
			}
		} else {
			return false;
		}
	}
	
	public static ConcurrentHashMap<String, Long> warriorEffectCripplingPlayer = new ConcurrentHashMap<String, Long>();
	
	public static boolean getWarriorEffectCrippling(Player attacker, Player victim) {
		String playername = attacker.getName();
		if (warriorEffectCripplingPlayer.containsKey(playername)) {
			Long now = System.currentTimeMillis();
			warriorEffectCripplingSkillPlayer.put(victim.getName(), warriorEffectCripplingPlayer.get(playername));
			warriorEffectCripplingSkillUseTime.put(victim.getName(), now);
			warriorEffectCripplingPlayer.remove(playername);
			victim.sendMessage(ChatColor.GRAY + "*** You have been crippled!");
			attacker.sendMessage(ChatColor.GRAY + "*** You have used crippling!");
			return true;
		} else {
			return false;
		}
	}

	public static void setWarriorEffectCrippling(String playername, Long duration) {
		warriorEffectCripplingPlayer.put(playername, duration);
	}
	
	public static ConcurrentHashMap<String, Integer> warriorEffectSkullSplitterPlayer = new ConcurrentHashMap<String, Integer>();
	
	public static boolean getWarriorEffectSkullSplitter(Player attacker, LivingEntity entity) {
		String playername = attacker.getName();
		if (warriorEffectSkullSplitterPlayer.containsKey(playername)) {
			Block block = entity.getLocation().getBlock().getRelative(BlockFace.DOWN);
			block = block.getRelative(BlockFace.DOWN);
			
			entity.damage(warriorEffectSkullSplitterPlayer.get(playername));
			entity.teleport(block.getLocation());
			attacker.sendMessage(ChatColor.GRAY + "*** You have used skullsplitter!");
			if (entity instanceof Player) {
				((Player) entity).sendMessage(ChatColor.GRAY + "*** You have been hit by " + attacker.getName() + "'s skullsplitter! Jump!");
			}
			warriorEffectSkullSplitterPlayer.remove(playername);
			
			return true;
		} else {
			return false;
		}
	}

	public static void setWarriorEffectSkullSplitter(String playername, int extraDamage) {
		warriorEffectSkullSplitterPlayer.put(playername, extraDamage);
	}
}
