package de.web.minecraftandi;

import java.util.ArrayList;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.craftbukkit.entity.CraftPlayer;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;

public class xMagician {
	public static boolean skill1(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.TORCH;
		boolean hasItem = false;
		if (!xConfig.needItems) {
			hasItem = true;
		}
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			hasItem = true;
		}
		
		if (hasItem) {
			String playerData = xDataManager.getData(playername);
			String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int distance = 20;
			if (level >= 11) {
				distance = 30;
			}
			
			int damage = 2;
			if (level >= 16) {
				damage = 3;
			}
			
			Block targetBlock = player.getTargetBlock(null, distance);
			Player[] playerList = player.getServer().getOnlinePlayers();
			
			boolean canUse = false;
			for (Player victim : playerList) {
				Location loc1 = targetBlock.getLocation();
				Location loc2 = victim.getLocation();
			 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
			 	if (distanceAway >= 3.0D)
					continue;
				victim.damage(damage);
				player.sendMessage(ChatColor.GRAY + "*** You have cast an energy wave!");
				victim.sendMessage(ChatColor.GRAY + "*** You have been hit by an energy wave!");
				canUse = true;
			}
			
			if (canUse) {
				if (xConfig.needItems) {
					ItemStack item = playerInventory.getItem(itemSlot);
					amount = item.getAmount();
					if (amount == 1) {
						ItemStack[] contents = playerInventory.getContents();
						boolean remove = true;
						for (int i = 0; i < contents.length; i++) {
							if (playerInventory.getItem(i).getType() == itemNeeded) {
								int itemAmount = playerInventory.getItem(i).getAmount();
								if (itemAmount == 1 && remove) {
									contents[i].setType(Material.AIR);
									remove = false;
								}
							}
						}
						playerInventory.setContents(contents);
						((CraftPlayer)player).getHandle().activeContainer.a();
					} else {
						item.setAmount(amount - 1);
					}
				}
				int exp = Integer.parseInt(split[2]);
				exp = exp + 10;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
			return canUse;
		} else {
			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You need a " + itemNeeded + " to cast this spell!");
			return false;
		}
	}
	
	public static boolean skill2(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		
		String playerData = xDataManager.getData(playername);
    	String[] split = playerData.split(" ");
		int level = Integer.parseInt(split[1]);
		
		int distance = 10;
		if (level >= 12) {
			distance = 20;
		}
		if (level >= 17) {
			distance = 30;
		}
		
		boolean canUse = false;
		Block targetBlock = player.getTargetBlock(null, distance);
		Block oneAbove = targetBlock.getRelative(BlockFace.UP);
		Block twoAbove = oneAbove.getRelative(BlockFace.UP);
		if ((oneAbove.getType() == Material.AIR) && (twoAbove.getType() == Material.AIR)) {
			Location loc1 = player.getLocation();
			Location loc2 = targetBlock.getLocation();
			double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
			switch(distance) {
				case 10:
					if (distanceAway <= 10.0D) {
						player.sendMessage(ChatColor.GRAY + "*** You have yourself teleported!");
						canUse = true;
						player.teleport(targetBlock.getRelative(BlockFace.UP).getLocation());
					} else {
						player.sendMessage(ChatColor.GRAY + "*** You can not teleport that far!");
					}
					break;
				case 20:
					if (distanceAway <= 20.0D) {
						player.sendMessage(ChatColor.GRAY + "*** You have yourself teleported!");
						canUse = true;
						player.teleport(targetBlock.getRelative(BlockFace.UP).getLocation());
					} else {
						player.sendMessage(ChatColor.GRAY + "*** You can not teleport that far!");
					}
					break;
				case 30:
					if (distanceAway <= 30.0D) {
						player.sendMessage(ChatColor.GRAY + "*** You have yourself teleported!");
						canUse = true;
						player.teleport(targetBlock.getRelative(BlockFace.UP).getLocation());
					} else {
						player.sendMessage(ChatColor.GRAY + "*** You can not teleport that far!");
					}
					break;
				default:
					player.sendMessage(ChatColor.GRAY + "*** You found a bug! Please report an admin!");
					break;
			}
		} else {
			player.sendMessage(ChatColor.GRAY + "*** You can not teleport there!");
		}
		
		if (canUse) {
			int exp = Integer.parseInt(split[2]);
			exp = exp + 15;
			if (exp>=(300*(level+1))) {
				exp = 0;
				if(level<20) {
					level++;
				}
				player.sendMessage(ChatColor.YELLOW + "[xLevel]");
				player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
				if (split[0].equalsIgnoreCase("Commoner")) {
					player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
				}
				if (level == 20) {
					player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
				}
			}
			
			String[] split2 = playerData.split(" ");
			playerData = split2[0] + " " + level + " " + exp;
			xDataManager.setData(playername, playerData);
		}
		return canUse;
	}

	public static boolean skill3(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.SNOW_BALL;
		boolean hasItem = false;
		if (!xConfig.needItems) {
			hasItem = true;
		}
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			hasItem = true;
		}
		
		if (hasItem) {
			String playerData = xDataManager.getData(playername);
	    	String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int distance = 20;
			if (level >= 13) {
				distance = 30;
			}

			int damage = 2;
			if (level >= 18) {
				damage = 4;
			}
			
			boolean canUse = false;
			ArrayList<Block> blockList = new ArrayList<Block>();
			Player[] playerList = player.getServer().getOnlinePlayers();
			Block targetBlock = player.getTargetBlock(null, distance);
			Block eastBlock = targetBlock.getRelative(BlockFace.EAST);
			Block westBlock = targetBlock.getRelative(BlockFace.WEST);
			Block northBlock = targetBlock.getRelative(BlockFace.NORTH);
			Block southBlock = targetBlock.getRelative(BlockFace.SOUTH);
			Block northEastBlock = targetBlock.getRelative(BlockFace.NORTH_EAST);
			Block northWestBlock = targetBlock.getRelative(BlockFace.NORTH_WEST);
			Block southEastBlock = targetBlock.getRelative(BlockFace.SOUTH_EAST);
			Block southWestBlock = targetBlock.getRelative(BlockFace.SOUTH_WEST);
			Block targetUp = targetBlock.getRelative(BlockFace.UP);
			Block eastUp = eastBlock.getRelative(BlockFace.UP);
			Block westUp = westBlock.getRelative(BlockFace.UP);
			Block northUp = northBlock.getRelative(BlockFace.UP);
			Block southUp = southBlock.getRelative(BlockFace.UP);
			Block northEastUp = northEastBlock.getRelative(BlockFace.UP);
			Block northWestUp = northWestBlock.getRelative(BlockFace.UP);
			Block southEastUp = southEastBlock.getRelative(BlockFace.UP);
			Block southWestUp = southWestBlock.getRelative(BlockFace.UP);
			
			for (Player victim : playerList) {
				Location loc1 = targetBlock.getLocation();
				Location loc2 = victim.getLocation();
				double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
				if (distanceAway >= 3.0D)
					continue;
					player.sendMessage(ChatColor.GRAY + "*** You have cast an icy wind!");
					victim.sendMessage(ChatColor.GRAY + "*** You have been hit by an icy wind!");
					victim.damage(damage);
				
				if ((targetBlock.getRelative(BlockFace.UP).getType() == Material.AIR) && (targetBlock.getRelative(BlockFace.DOWN).getType() != Material.AIR)) {
					targetBlock.getRelative(BlockFace.UP).setType(Material.SNOW);
					blockList.add(targetUp);
					canUse = true;
				}
				if (canUse) {
					if (eastBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						eastBlock.getRelative(BlockFace.UP).setType(Material.SNOW);
						blockList.add(eastUp);
					}
					if (westBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						westBlock.getRelative(BlockFace.UP).setType(Material.SNOW);
						blockList.add(westUp);
					}
					if (northBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						northBlock.getRelative(BlockFace.UP).setType(Material.SNOW);
						blockList.add(northUp);
					}
					if (southBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						southBlock.getRelative(BlockFace.UP).setType(Material.SNOW);
						blockList.add(southUp);
					}
					if (northEastBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						northEastBlock.getRelative(BlockFace.UP).setType(Material.SNOW);
						blockList.add(northEastUp);
					}
					if (northWestBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						northWestBlock.getRelative(BlockFace.UP).setType(Material.SNOW);
						blockList.add(northWestUp);
					}
					if (southEastBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						southEastBlock.getRelative(BlockFace.UP).setType(Material.SNOW);
						blockList.add(southEastUp);
					}
					if (southWestBlock.getRelative(BlockFace.UP).getType() == Material.AIR) {
						southWestBlock.getRelative(BlockFace.UP).setType(Material.SNOW);
						blockList.add(southWestUp);
					}
				}
				canUse = true;
				
				xEffectManager.setMagicianEffectIcyWind(victim.getName(), blockList);
			}
			
			if (canUse) {
				if (xConfig.needItems) {
					ItemStack item = playerInventory.getItem(itemSlot);
					amount = item.getAmount();
					if (amount == 1) {
						ItemStack[] contents = playerInventory.getContents();
						boolean remove = true;
						for (int i = 0; i < contents.length; i++) {
							if (playerInventory.getItem(i).getType() == itemNeeded) {
								int itemAmount = playerInventory.getItem(i).getAmount();
								if (itemAmount == 1 && remove) {
									contents[i].setType(Material.AIR);
									remove = false;
								}
							}
						}
						playerInventory.setContents(contents);
						((CraftPlayer)player).getHandle().activeContainer.a();
					} else {
						item.setAmount(amount - 1);
					}
				}
				int exp = Integer.parseInt(split[2]);
				exp = exp + 20;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
			
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
			return canUse;
		} else {
			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You need a " + itemNeeded + " to cast this spell!");
			return false;
		}
	}

	public static boolean skill4(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.SAPLING;
		boolean hasItem = false;
		if (!xConfig.needItems) {
			hasItem = true;
		}
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			hasItem = true;
		}
		
		if (hasItem) {
			String playerData = xDataManager.getData(playername);
	    	String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int distance = 10;
			if (level >= 14) {
				distance = 20;
			}
			
			int damage = 0;
			if (level >= 19) {
				damage = 2;
			}
			
			Block targetBlock = player.getTargetBlock(null, distance);
			Player[] playerList = player.getServer().getOnlinePlayers();
			
			boolean canUse = false;
			for (Player victim : playerList) {
				Location loc1 = targetBlock.getLocation();
				Location loc2 = victim.getLocation();
			 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
			 	if (distanceAway >= 3.0D)
					continue;
			 	canUse = true;
			 	if (damage != 0) {
				 	victim.damage(damage);
			 	}
				player.sendMessage(ChatColor.GRAY + "*** You have cast a leaves jail!");
				victim.sendMessage(ChatColor.GRAY + "*** You have been imprisoned in a leaves jail!");
			
				ArrayList<Block> blockList = new ArrayList<Block>();
				Block[] area = new Block[50];
				area[25] = player.getTargetBlock(null, distance);
				area[25] = area[25].getRelative(BlockFace.UP);
				area[24] = area[25].getRelative(BlockFace.WEST);
				area[23] = area[24].getRelative(BlockFace.WEST);
				area[22] = area[23].getRelative(BlockFace.WEST);
				area[15] = area[22].getRelative(BlockFace.NORTH);
				area[8] = area[15].getRelative(BlockFace.NORTH);
				area[1] = area[8].getRelative(BlockFace.NORTH);
				area[2] = area[1].getRelative(BlockFace.EAST);
				area[3] = area[2].getRelative(BlockFace.EAST);
				area[4] = area[3].getRelative(BlockFace.EAST);
				area[5] = area[4].getRelative(BlockFace.EAST);
				area[6] = area[5].getRelative(BlockFace.EAST);
				area[7] = area[6].getRelative(BlockFace.EAST);
		        area[9] = area[8].getRelative(BlockFace.EAST);
		        area[10] = area[9].getRelative(BlockFace.EAST);
		        area[11] = area[10].getRelative(BlockFace.EAST);
				area[12] = area[11].getRelative(BlockFace.EAST);
				area[13] = area[12].getRelative(BlockFace.EAST);
				area[14] = area[13].getRelative(BlockFace.EAST);
				area[16] = area[15].getRelative(BlockFace.EAST);
				area[17] = area[16].getRelative(BlockFace.EAST);
				area[18] = area[17].getRelative(BlockFace.EAST);
				area[19] = area[18].getRelative(BlockFace.EAST);
				area[20] = area[19].getRelative(BlockFace.EAST);
				area[21] = area[20].getRelative(BlockFace.EAST);
				area[26] = area[25].getRelative(BlockFace.EAST);
				area[27] = area[26].getRelative(BlockFace.EAST);
				area[28] = area[27].getRelative(BlockFace.EAST);
				area[29] = area[22].getRelative(BlockFace.SOUTH);
				area[30] = area[29].getRelative(BlockFace.EAST);
				area[31] = area[30].getRelative(BlockFace.EAST);
				area[32] = area[31].getRelative(BlockFace.EAST);
				area[33] = area[32].getRelative(BlockFace.EAST);
				area[34] = area[33].getRelative(BlockFace.EAST);
				area[35] = area[34].getRelative(BlockFace.EAST);
				area[36] = area[29].getRelative(BlockFace.SOUTH);
				area[37] = area[36].getRelative(BlockFace.EAST);
				area[38] = area[37].getRelative(BlockFace.EAST);
				area[39] = area[38].getRelative(BlockFace.EAST);
				area[40] = area[39].getRelative(BlockFace.EAST);
				area[41] = area[40].getRelative(BlockFace.EAST);
				area[42] = area[41].getRelative(BlockFace.EAST);
				area[43] = area[36].getRelative(BlockFace.SOUTH);
				area[44] = area[43].getRelative(BlockFace.EAST);
				area[45] = area[44].getRelative(BlockFace.EAST);
				area[46] = area[45].getRelative(BlockFace.EAST);
				area[47] = area[46].getRelative(BlockFace.EAST);
				area[48] = area[47].getRelative(BlockFace.EAST);
				area[49] = area[48].getRelative(BlockFace.EAST);
				for (int i = 1; i < 50; i++) {
					if ((i == 17) || (i == 18) || (i == 19) || (i == 24) || (i == 25) || (i == 26) || (i == 31) || (i == 32) || (i == 33))
						continue;
					if (area[i].getType() != Material.AIR)
						continue;
					area[i].setType(Material.LEAVES);
					blockList.add(area[i]);
				}
				Block[] area2 = new Block[50];
				for (int i = 1; i < 50; i++) {
					area2[i] = area[i].getRelative(BlockFace.UP);
					if ((i == 17) || (i == 18) || (i == 19) || (i == 24) || (i == 25) || (i == 26) || (i == 31) || (i == 32) || (i == 33))
						continue;
					if (area2[i].getType() != Material.AIR)
						continue;
					area2[i].setType(Material.LEAVES);
					blockList.add(area[i]);
				}
				Block[] area3 = new Block[50];
				for (int i = 1; i < 50; i++) {
					area3[i] = area2[i].getRelative(BlockFace.UP);
					if ((i == 1) || (i == 2) || (i == 3) || (i == 4) || (i == 5) || (i == 6) || (i == 7) || (i == 14) || (i == 21) || (i == 28) || (i == 35) || (i == 42) || (i == 49) || (i == 48) || (i == 47) || (i == 46) || (i == 45) || (i == 44) || (i == 43) || (i == 36) || (i == 29) || (i == 22) || (i == 15) || (i == 8))
						continue;
					if (area3[i].getType() != Material.AIR)
						continue;
					area3[i].setType(Material.LEAVES);
					blockList.add(area[i]);
				}
				Block x = area3[25].getRelative(BlockFace.UP);
				if (x.getType() == Material.AIR) {
					x.setType(Material.LEAVES);
					blockList.add(x);
				}
				if (x.getRelative(BlockFace.UP).getType() == Material.AIR) {
					x.getRelative(BlockFace.UP).setType(Material.LEAVES);
					blockList.add(x.getRelative(BlockFace.UP));
				}
				if (x.getRelative(BlockFace.EAST).getType() == Material.AIR) {
					x.getRelative(BlockFace.EAST).setType(Material.LEAVES);
					blockList.add(x.getRelative(BlockFace.EAST));
				}
				if (x.getRelative(BlockFace.SOUTH).getType() == Material.AIR) {
					x.getRelative(BlockFace.SOUTH).setType(Material.LEAVES);
					blockList.add(x.getRelative(BlockFace.SOUTH));
				}
				if (x.getRelative(BlockFace.WEST).getType() == Material.AIR) {
					x.getRelative(BlockFace.WEST).setType(Material.LEAVES);
					blockList.add(x.getRelative(BlockFace.WEST));
				}
				if (x.getRelative(BlockFace.NORTH).getType() == Material.AIR)
				{
					x.getRelative(BlockFace.NORTH).setType(Material.LEAVES);
					blockList.add(x.getRelative(BlockFace.NORTH));
				}

				xEffectManager.setMagicianEffectLeavesJail(victim.getName(), blockList);
			}
			
			if (canUse) {
				if (xConfig.needItems) {
					ItemStack item = playerInventory.getItem(itemSlot);
					amount = item.getAmount();
					if (amount == 1) {
						ItemStack[] contents = playerInventory.getContents();
						boolean remove = true;
						for (int i = 0; i < contents.length; i++) {
							if (playerInventory.getItem(i).getType() == itemNeeded) {
								int itemAmount = playerInventory.getItem(i).getAmount();
								if (itemAmount == 1 && remove) {
									contents[i].setType(Material.AIR);
									remove = false;
								}
							}
						}
						playerInventory.setContents(contents);
						((CraftPlayer)player).getHandle().activeContainer.a();
					} else {
						item.setAmount(amount - 1);
					}
				}
				int exp = Integer.parseInt(split[2]);
				exp = exp + 25;
				if (exp>=(300*(level+1))) {
					exp = 0;
					if(level<20) {
						level++;
					}
					player.sendMessage(ChatColor.YELLOW + "[xLevel]");
					player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
					if (split[0].equalsIgnoreCase("Commoner")) {
						player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
					}
					if (level == 20) {
						player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
					}
				}
				
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(playername, playerData);
			}
			return canUse;
		} else {
			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You need a " + itemNeeded + " to cast this spell!");
			return false;
		}
	}

	public static boolean skill5(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		String playername = player.getName();
		Material itemNeeded = Material.REDSTONE_TORCH_ON;
		boolean hasItem = false;
		if (!xConfig.needItems) {
			hasItem = true;
		}
		
		PlayerInventory playerInventory = player.getInventory();
		int amount = 0;
		int itemSlot = playerInventory.first(itemNeeded);
		
		if (itemSlot != -1) {
			if (xConfig.needItems) {
				ItemStack item = playerInventory.getItem(itemSlot);
				amount = item.getAmount();
				if (amount == 1) {
					ItemStack[] contents = playerInventory.getContents();
					boolean remove = true;
					for (int i = 0; i < contents.length; i++) {
						if (playerInventory.getItem(i).getType() == itemNeeded) {
							int itemAmount = playerInventory.getItem(i).getAmount();
							if (itemAmount == 1 && remove) {
								contents[i].setType(Material.AIR);
								remove = false;
							}
						}
					}
					playerInventory.setContents(contents);
					((CraftPlayer)player).getHandle().activeContainer.a();
				} else {
					item.setAmount(amount - 1);
				}
				hasItem = true;
			}
		}
		
		if (hasItem) {
			player.sendMessage(ChatColor.GRAY + "*** You have cast a lightning strike!");
			
			String playerData = xDataManager.getData(playername);
	    	String[] split = playerData.split(" ");
			int level = Integer.parseInt(split[1]);
			
			int distance = 20;
			if (level >= 15) {
				distance = 30;
			}
			
			int extraDamage = 0;
			if (level >= 20) {
				extraDamage = 1;
			}
			
			Block targetBlock = player.getTargetBlock(null, distance);
			Location targetLocation = targetBlock.getLocation();
			player.getWorld().strikeLightning(targetLocation);
			Player[] playerList = player.getServer().getOnlinePlayers();
			
			for (Player victim : playerList) {
				Location loc1 = targetBlock.getLocation();
				Location loc2 = victim.getLocation();
			 	double distanceAway = Math.sqrt(Math.pow(loc1.getX() - loc2.getX(), 2.0D) + Math.pow(loc1.getY() - loc2.getY(), 2.0D) + Math.pow(loc1.getZ() - loc2.getZ(), 2.0D));
			 	if (distanceAway >= 3.0D)
					continue;
				victim.damage(extraDamage);
				victim.sendMessage(ChatColor.GRAY + "*** You have been hit by an lightning strike!");
			}
			
			int exp = Integer.parseInt(split[2]);
			exp = exp + 30;
			if (exp>=(300*(level+1))) {
				exp = 0;
				if(level<20) {
					level++;
				}
				player.sendMessage(ChatColor.YELLOW + "[xLevel]");
				player.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
				if (split[0].equalsIgnoreCase("Commoner")) {
					player.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
				}
				if (level == 20) {
					player.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
				}
			}
			
			String[] split2 = playerData.split(" ");
			playerData = split2[0] + " " + level + " " + exp;
			xDataManager.setData(playername, playerData);
			return true;
		} else {
			player.sendMessage(ChatColor.YELLOW + "[xL]" + ChatColor.GRAY + " You need a " + itemNeeded + " to cast this spell!");
			return false;
		}
	}
}
