package de.web.minecraftandi;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;

/**
 * Handle commands sent by players
 * @author Andi
 */
public class xCommandListener extends PlayerListener {
    public xCommandListener(xLevel instance) {
	}
	
	public void onPlayerCommandPreprocess(PlayerCommandPreprocessEvent event) {
		Player player = event.getPlayer();
		String command = event.getMessage();
		boolean xlCommand = false;
		
		if((command.equalsIgnoreCase("/xl")) || (command.equalsIgnoreCase("/xl help"))) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.help")) {
					xCommands.xCommandHelp(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandHelp(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				xCommands.xCommandHelp(event);
			}
			xlCommand = true;
		}

		if(command.equalsIgnoreCase("/xl status")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.status")) {
					xCommands.xCommandStatus(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandStatus(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				xCommands.xCommandStatus(event);
			}
			xlCommand = true;
		}

		if(command.equalsIgnoreCase("/xl classes")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.classes")) {
					xCommands.xCommandClasses(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandClasses(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				xCommands.xCommandClasses(event);
			}
			xlCommand = true;
		}
		
		if(command.equalsIgnoreCase("/xl see archer")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.see.archer")) {
					xCommands.xCommandSeeArcher(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandSeeArcher(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				xCommands.xCommandSeeArcher(event);
			}
			xlCommand = true;
		}
		
		if(command.equalsIgnoreCase("/xl see warrior")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.see.warrior")) {
					xCommands.xCommandSeeWarrior(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandSeeWarrior(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				xCommands.xCommandSeeWarrior(event);
			}
			xlCommand = true;
		}
		
		if(command.equalsIgnoreCase("/xl see magician")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.see.magician")) {
					xCommands.xCommandSeeMagician(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandSeeMagician(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				xCommands.xCommandSeeMagician(event);
			}
			xlCommand = true;
		}
		
		if(command.equalsIgnoreCase("/xl see priest")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.see.priest")) {
					xCommands.xCommandSeePriest(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandSeePriest(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				xCommands.xCommandSeePriest(event);
			}
			xlCommand = true;
		}

		if((command.startsWith("/xl class")) && (!command.equalsIgnoreCase("/xl classes"))) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.class") && xConfig.playersCanChooseClass) {
					xCommands.xCommandClass(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandClass(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if (xConfig.playersCanChooseClass) {
					xCommands.xCommandClass(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}

		if(command.equalsIgnoreCase("/xl reset")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.reset") && xConfig.playersCanReset) {
					xCommands.xCommandReset(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandReset(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if (xConfig.playersCanReset) {
					xCommands.xCommandReset(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}

		if(command.equalsIgnoreCase("/xl reset yes")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.player.reset") && xConfig.playersCanReset) {
					xCommands.xCommandResetYes(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandResetYes(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if (xConfig.playersCanReset) {
					xCommands.xCommandResetYes(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if(command.equalsIgnoreCase("/xl admin")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.admin.help")) {
					xCommands.xCommandAdmin(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandAdmin(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if(player.isOp()) {
					xCommands.xCommandAdmin(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if(command.startsWith("/xl setclass")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.admin.setclass")) {
					xCommands.xCommandSetClass(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandSetClass(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if(player.isOp()) {
					xCommands.xCommandSetClass(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if(command.startsWith("/xl setlevel")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.admin.setlevel")) {
					xCommands.xCommandSetLevel(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandSetLevel(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if(player.isOp()) {
					xCommands.xCommandSetLevel(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if(command.startsWith("/xl setexp")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.admin.setexp")) {
					xCommands.xCommandSetExp(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandSetExp(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if(player.isOp()) {
					xCommands.xCommandSetExp(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if(command.startsWith("/xl get")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.admin.get") || xConfig.playersCanSeeOthers) {
					xCommands.xCommandGet(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandGet(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if(player.isOp() || xConfig.playersCanSeeOthers) {
					xCommands.xCommandGet(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if(command.startsWith("/xl new")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.admin.new")) {
					xCommands.xCommandNew(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandNew(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if(player.isOp()) {
					xCommands.xCommandNew(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if(command.startsWith("/xl resetall")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.admin.resetall")) {
					xCommands.xCommandResetAll(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandResetAll(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if(player.isOp()) {
					xCommands.xCommandResetAll(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if (xlCommand) {
			event.setCancelled(true);
		}
		
		if(command.equalsIgnoreCase("/xl save")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.admin.save")) {
					xCommands.xCommandSave(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandSave(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if(player.isOp()) {
					xCommands.xCommandSave(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if (xlCommand) {
			event.setCancelled(true);
		}
		
		if(command.equalsIgnoreCase("/xl reload")) {
			if(xConfig.usePermissions) {
				if (xLevel.permissionHandler.has(player, "xlevel.admin.reload")) {
					xCommands.xCommandReload(event);
				} else {
					if ((xConfig.opIsAdmin) && (player.isOp())) {
						xCommands.xCommandReload(event);
					} else {
						player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
					}
				}
			} else {
				if(player.isOp()) {
					xCommands.xCommandReload(event);
				} else {
					player.sendMessage(ChatColor.RED + "You don't have permission to do that!");
				}
			}
			xlCommand = true;
		}
		
		if (xlCommand) {
			event.setCancelled(true);
		}
	}
}
