package de.web.minecraftandi;

import org.bukkit.ChatColor;
import org.bukkit.entity.Creature;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityDeathEvent;
import org.bukkit.event.entity.EntityTargetEvent;
import org.bukkit.event.entity.EntityListener;

/**
 * Handle entity related events
 * @author Andi
 */
public class xEntityListener extends EntityListener{
	private final xLevel plugin;

    public xEntityListener(xLevel instance) {
        plugin = instance;
    }
	public static boolean preventRepeatP = false;
	public static boolean preventRepeatC = false;
	public static int lastDiedP = -1;
	public static int lastDiedC = -1;
	
    public void onEntityDamage(EntityDamageEvent event){
        if(event instanceof EntityDamageByEntityEvent) {
            Entity damager = ((EntityDamageByEntityEvent) event).getDamager();
            Entity entity = event.getEntity();
            
            
            if (event.isCancelled())
            	return;
            if (event.getCause() != EntityDamageEvent.DamageCause.ENTITY_ATTACK)
            	return;
			if (!(event instanceof EntityDamageByEntityEvent)) {
	   			return;
   			}
			
			if(damager instanceof Player) {
		    	if (xEffectManager.getArcherEffectInvisible(((Player) damager).getName())) {
		    		xArcher.removeInvisible((Player)damager);
				}
		    	String playername2 = ((Player) damager).getName();
		    	
		    	String playerData2 = xDataManager.getData(playername2);
		    	String[] split = playerData2.split(" ");
		    	
		    	if (split[0].equalsIgnoreCase("Warrior")) {
		    		xEffectManager.getWarriorEffectPush((Player) damager, (LivingEntity) entity);
		    		xEffectManager.getWarriorEffectSkullSplitter((Player) damager, (LivingEntity) entity);
		    		if (entity instanceof Player) {
		    			xEffectManager.getWarriorEffectCrippling((Player) damager, (Player) entity);
		    		}
		    	}
			}
			
			if(entity instanceof Player) {
				String playername = ((Player) entity).getName();
		    	
		    	String playerData = xDataManager.getData(playername);
		    	String[] split = playerData.split(" ");
		    	
		    	if (split[0].equalsIgnoreCase("Warrior")) {
		    		int level = Integer.parseInt(split[1]);
		    		
		    		if (level >= 4) {
			    		int levelMultiplier = 12;
			    		if (level >= 19) {
			    			levelMultiplier = 6;
			    		} else if (level >= 14) {
			    			levelMultiplier = 8;
			    		} else if (level >= 9) {
			    			levelMultiplier = 10;
			    		}
			    		
			    		int random = (int) ((Math.random()*levelMultiplier)+1);
			    		if (random == 3) {
			    			if (damager instanceof Player) {
				    			((Player) damager).sendMessage(ChatColor.GRAY + "*** " + ((Player) entity).getName() + " blocked your attack!");
				    			((Player) entity).sendMessage(ChatColor.GRAY + "*** You blocked an attack from " + ((Player) damager).getName() + "!");
			    			} else {
				    			((Player) entity).sendMessage(ChatColor.GRAY + "*** You blocked an attack from a mob!");
			    			}
			    			event.setCancelled(true);
			    		}
		    		}
		    	}
		    	
		    	if (xEffectManager.getArcherEffectInvisible(playername)) {
			    	Player[] playerlist = plugin.getServer().getOnlinePlayers();
			    	for (Player player2 : playerlist) {
				    	if (xEffectManager.getArcherEffectInvisible(player2.getName())) {
				    		xArcher.setInvisible(player2);
						}
			    	}
			    	event.setCancelled(true);
		    	}
			}
			
            if ((damager instanceof Player) && (entity instanceof Creature) && (!entity.isDead())) {
            	if (!preventRepeatC) {
            		//preventRepeatC = true;
	            	Player damagerP = (Player)damager;
	            	Creature entityC = (Creature)entity;
	            	int entityCId = entityC.getEntityId();
	            	int entityCHealth = entityC.getHealth() - event.getDamage();
	            	
	            	if (xEffectManager.getPriestEffectStrBuff(damagerP.getName())) {
	            		event.setDamage(event.getDamage() + 1);
	            	}
	            	
	            	
	            	if(entityCHealth <= 0 && (lastDiedC != entityCId)) {
	            		
	            		String playerData = xDataManager.getData(damagerP.getName());
	            		if (!playerData.equalsIgnoreCase("none")) {
		                	String[] split = playerData.split(" ");
		            		int level = Integer.parseInt(split[1]);
		            		int exp = Integer.parseInt(split[2]);
	            			exp = exp + 5;
	            			if (exp>=(300*(level+1))) {
	            				exp = 0;
	            				if(level<20) {
	            					level++;
	            				}
	            				damagerP.sendMessage(ChatColor.YELLOW + "[xLevel]");
	            				damagerP.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
	            				if (split[0].equalsIgnoreCase("Commoner")) {
	            					damagerP.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
	            				}
	            				if (level == 20) {
	            					damagerP.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
	            				}
	            			}
	            			String[] split2 = playerData.split(" ");
	            			playerData = split2[0] + " " + level + " " + exp;
	            			xDataManager.setData(damagerP.getName(), playerData);
	            		}
	            		
	            		lastDiedC = entityCId;
	            	}
	            } else {
	            	preventRepeatC = false;
	            }
            } else if((damager instanceof Player) && (entity instanceof Player) && (!entity.isDead())) {
            	if (!preventRepeatP) {
            		//preventRepeatP = true;
	            	Player damagerP = (Player)damager;
	            	Player entityP = (Player)entity;
	            	int entityPId = entityP.getEntityId();
	            	int entityPHealth = entityP.getHealth() - event.getDamage();

	            	if (xEffectManager.getPriestEffectStrBuff(damagerP.getName())) {
	            		event.setDamage(event.getDamage() + 1);
	            	}
	            	
	            	if (xEffectManager.getPriestEffectDefBuff(entityP.getName())) {
	            		event.setDamage(event.getDamage() - 1);
	            	}
	            	
            		if(event.getDamage() < 0) {
            			event.setDamage(0);
            		}
	            	if(entityPHealth <= 0 && (lastDiedP != entityPId)) {
	            		
	            		String playerData = xDataManager.getData(damagerP.getName());
	            		if (!playerData.equalsIgnoreCase("none")) {
		                	String[] split = playerData.split(" ");
		            		int level = Integer.parseInt(split[1]);
		            		int exp = Integer.parseInt(split[2]);
	            			exp = exp + 20;
	            			if (exp>=(300*(level+1))) {
	            				exp = 0;
	            				if(level<20) {
	            					level++;
	            				}
	            				damagerP.sendMessage(ChatColor.YELLOW + "[xLevel]");
	            				damagerP.sendMessage(ChatColor.GRAY + " You have reached level " + level + "!");
	            				if (split[0].equalsIgnoreCase("Commoner")) {
	            					damagerP.sendMessage(ChatColor.GRAY + " You can choose your class using " + ChatColor.LIGHT_PURPLE + "/xl classes");
	            				}
	            				if (level == 20) {
	            					damagerP.sendMessage(ChatColor.GRAY + " Congratulations! You reached the highest level!");
	            				}
	            			}
	            			String[] split2 = playerData.split(" ");
	            			playerData = split2[0] + " " + level + " " + exp;
	            			xDataManager.setData(damagerP.getName(), playerData);
	            		}
	            		
	            		lastDiedP = entityPId;
	            	}
	            } else {
	            	preventRepeatP = false;
	            }
            } else if((damager instanceof Entity) && (entity instanceof Player) && (!entity.isDead())) {
            	Player entityP = (Player)entity;

            	if (xEffectManager.getPriestEffectDefBuff(entityP.getName())) {
            		event.setDamage(event.getDamage() - 1);
            	}preventRepeatP = false;
            }
        }
    }
    
    public void onEntityDeath(EntityDeathEvent event) {
        Entity entity = event.getEntity();
        if (entity instanceof Player) {
        	Player entityP = (Player)entity;
        	
        	String playerData = xDataManager.getData(entityP.getName());
        	if (!playerData.equalsIgnoreCase("none")) {
	        	String[] split = playerData.split(" ");
	    		int level = Integer.parseInt(split[1]);
	    		int exp = Integer.parseInt(split[2]);
	    		if (exp >= 5) {
	    			exp = exp - 5;
	    		}
				String[] split2 = playerData.split(" ");
				playerData = split2[0] + " " + level + " " + exp;
				xDataManager.setData(entityP.getName(), playerData);
        	}
	    }
    }
    
    public void onEntityTarget(EntityTargetEvent event) {
    	Entity target = event.getTarget();

		if (event.isCancelled()) {
	    	return;
		}

    	if (target instanceof Player) {
    		if (xEffectManager.getArcherEffectInvisible(((Player) target).getName())) {
    			event.setCancelled(true);
    		}
    	}
    }
}
